﻿#include "ContinuousParticle.h"
#include "RandomVariates.h"

//This function is the actual objective value (without noise)
	//You can write your own test function here. Ackely function is used as a sample to show how to write your own test function
	double objectiveValueWithoutNoise(vector<double> &newVector)
	{
	double objective=0;
	
	
	//***********************************************
	//Ackley
	//***********************************************
	objective=0;
	double sum1=0;
	double sum2=0;
	for(int i=0;i<newVector.size();i++)
	{
		sum1+=pow(newVector[i],2);
		sum2+=cos(2*3.14*newVector[i]);
	}
	objective=-20*exp((double)-0.2*sqrt((double)sum1/newVector.size()))-exp((double)sum2/newVector.size())+20+exp(1);		
	
	return objective;
	}

	//get and set functions for the class fields!
	 vector<double> Particle:: getEntireElement()
	{
		return this->elements;
	}
	double Particle::getElements(int index)
	{
		return this->elements[index];
	}
	void Particle::setElements(int index,double value)
	{
		this->elements[index]=value;
	}
	void Particle::setLbest(vector<double> &newLocalBest)
	{
		this->lBest=newLocalBest;
	}
	double Particle::getLbest(int index)
	{
		return lBest[index];
	}
	void Particle::setVelocity(int index,double value)
	{
		this->velocity[index]=value;
	}
	double Particle::getVelocity(int index)
	{
		return this->velocity[index];
	}
	//initialization of the class objects
	void Particle::initialize(int dimension)
	{
		elements.resize(dimension);
		velocity.resize(dimension);
		globalBest.resize(dimension);
		for(int i=0;i<dimension;i++)
		{
			elements[i]=getRandomNumber(-10,10);
			
		}
		//for the minimum objective function
		this->lBest=this->elements;
		this->globalBest=this->elements;

		for(int i=0;i<dimension;i++)
		{
			velocity[i]=0;
		}

		
	}

	//This function initilize the particles fields
	void Particle::initializeVector(vector<double> &newVector)
	{
		elements.resize(newVector.size());
		velocity.resize(newVector.size());
		globalBest.resize(newVector.size());
		elements=newVector;
		//for the minimum objective function
		this->lBest=this->elements;

		for(int i=0;i<newVector.size();i++)
		{
			velocity[i]=0;
		}
		//this->lBestValue=CalculateSampleMean(observations);


		
	}
	vector<double> Particle:: getEntireLBest()
	{
		return lBest;
	}
	vector<double> Particle:: getGlobalBest()
	{
		return this->globalBest;
	}
	void Particle::setGlobalBest(vector<double> &globalBest)
	{
		this->globalBest=globalBest;
	}
	void Particle:: setlBestValue(double value)
	{
		this->lBestValue=value;
	}
	double Particle::getlBestValue()
	{
		return this->lBestValue;
	}
	//finding if the current value is less than the local best or not(for the Min Objective)
	void FindLocalBest(vector<double> &newVector,Particle &particle,vector<double> &observations)
	{
		if (particle.getlBestValue() > CalculateSampleMean(observations))
		{
			particle.setLbest(newVector);
			particle.setlBestValue(CalculateSampleMean(observations));
		}
		
	}
	

	// Returns a pseudo-random integer between low and high.
	double Particle::getRandomNumber(double low, double high)
	{
		return low + ((high - low) + 1) * rand() / (RAND_MAX + 1.0); 
	}

//end of the particle class

	//This function calculates the sample mean of observations 
	double NoisyObjectiveValue(vector<double> &newVector,int numberOfObservations,double noiseVariance)
	{
		//int numberOfObservations=10;
		vector<double> observations;
		
		for(int j=0;j<numberOfObservations;j++)
		{
			observations.push_back(objectiveValueWithoutNoise(newVector)+Normal(0,noiseVariance));
		}
	return CalculateSampleMean(observations);
	
	}


	double CalculateSampleMean(vector<double> &observations)
{
	double sampleMean=0;
	for(int i=0;i<observations.size();i++)
	{
		//cout<<"observation: "<<i<<"is: "<<observations[i]<<endl;
		sampleMean+=observations[i];
	}
	sampleMean/=observations.size();
	return sampleMean;
}

double CalculateSampleVariance(vector<double> &observations)
{
	double sampleVariance=0;
	double sampleMean=CalculateSampleMean(observations);
	for(int i=0;i<observations.size();i++)
	{
		sampleVariance+=pow(observations[i]-sampleMean,2);
	}
	sampleVariance/=(observations.size()-1);
	return sampleVariance;

}

