#ifndef CONTINUOUSPARTICLE_H_
#define CONTINUOUSPARTICLE_H_
#include <iostream>
#include<ctime>
#include <vector>
#include<cmath>
using namespace std;

double NoisyObjectiveValue(vector<double> &newVector,int numberOfObservations,double noiseVariance);
class Particle
{
private:
	vector<double> elements;
	vector<double> lBest;
	vector<double> velocity;
	vector<double> globalBest;
	double lBestValue;
	
public:
	//get and set functions for the class fields!
	vector<double> getEntireElement();
	double getElements(int index);
	void setElements(int index,double value);
	void setLbest(vector<double> &newLocalBest);
	double getLbest(int index);
	vector<double> getEntireLBest();
	void setVelocity(int index,double value);
	double getVelocity(int index);
	//initialization of the class objects
	void initialize(int dimension);
	void Particle::initializeVector(vector<double> &newVector);
	//finding if the current value is less than the local best or not(for the Min Objective)
	vector<double> getGlobalBest();
	void setGlobalBest(vector<double> &globalBest);
	void setlBestValue(double value);
	double getlBestValue();
	

	// Returns a pseudo-random integer between low and high.
	double getRandomNumber(double low, double high);
};//end of the particle class
void FindLocalBest(vector<double> &newVector,Particle &particle,vector<double> &observations);
double objectiveValueWithoutNoise(vector<double> &newVector);
double CalculateSampleMean(vector<double> &observations);
double CalculateSampleVariance(vector<double> &observations);


#endif /*CONTINUOUSPARTICLE_H_*/
