#include "RngStream.h"

RngStream rng("rng");

double Normal(double mean, double variance)
{
    double u1, u2, v1, v2, w, x, y;
    do
    {
        u1 = rng.RandU01();
        u2 = rng.RandU01();
        v1 = 2 * u1 - 1;
        v2 = 2 * u2 - 1;
        w = v1 * v1 + v2 * v2; 
    }
    while (w > 1);
    y = sqrt(-2 * log(w) / w);
    x = v1 * y;
    // x is N(0,1)  
    double normal = mean + sqrt(variance) * x;
    return normal;
}

double Normal(double mean, double variance, RngStream& indrng)
{
    double u1, u2, v1, v2, w, x, y;
    do
    {
        u1 = indrng.RandU01();
        u2 = indrng.RandU01();
        v1 = 2 * u1 - 1;
        v2 = 2 * u2 - 1;
        w = v1 * v1 + v2 * v2; 
    }
    while (w > 1);
    y = sqrt(-2 * log(w) / w);
    x = v1 * y;
    // x is N(0,1)  
    double normal = mean + sqrt(variance) * x;
    return normal;
}


double Exponential(double arrivalRate)
{
	double u = rng.RandU01();
	return -log(u) / arrivalRate;
}


 



